/* Include Files */
#include "KTag.h"

static uint8_t SubmenuIndex = 0;
static MenuItem_T const * const Submenus[] = 
{
    &TeamIDMenuItem,
    &PlayerIDMenuItem
};
static const uint8_t N_SUBMENUS = (sizeof(Submenus) / sizeof(MenuItem_T *));

static void OnFocus(bool IncludeDetails);
static MenuItem_T const * OnSelect();
static void OnIncrement();
static void OnDecrement();

const MenuItem_T GameMenuItem =
{
    .OnFocus = OnFocus,
    .OnSelect = OnSelect,
    .OnIncrement = OnIncrement,
    .OnDecrement = OnDecrement
    
};

static void OnFocus(bool IncludeDetails)
{
    AudioAction_T audio_action = {.ID = AUDIO_PLAY_GAME_SETTINGS_PROMPT, .Data = (void *)0x00};
    xQueueSend(xQueueAudio, &audio_action, 0);
    
    if (IncludeDetails == true)
    {
        if (Submenus[SubmenuIndex]->OnFocus != NULL)
        {
            Submenus[SubmenuIndex]->OnFocus(false);
        }
    }
}

static MenuItem_T const * OnSelect()
{
    return Submenus[SubmenuIndex];
}

static void OnIncrement()
{
    if (SubmenuIndex < (N_SUBMENUS -1))
    {
        SubmenuIndex++;
    }
    else
    {
        // Wrap around.
        SubmenuIndex = 0;
    }
        
    if (Submenus[SubmenuIndex]->OnFocus != NULL)
    {
        Submenus[SubmenuIndex]->OnFocus(false);
    }
}

static void OnDecrement()
{
    if (SubmenuIndex > 0)
    {
        SubmenuIndex--;
    }
    else
    {
        // Wrap around.
        SubmenuIndex = (N_SUBMENUS -1);
    }    
        
    if (Submenus[SubmenuIndex]->OnFocus != NULL)
    {
        Submenus[SubmenuIndex]->OnFocus(false);
    }
}
